## sameboy 1.0.2+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(game.libretro.sameboy)

list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR})

find_package(Kodi REQUIRED)

# CMake on windows only searches for .lib libraries (static library or import library).
# The libretro game library is dynamically loaded so even if an import library would exists it's of no use.
if(CMAKE_SYSTEM_NAME STREQUAL Windows)
  set(_CMAKE_FIND_LIBRARY_SUFFIXES ${CMAKE_FIND_LIBRARY_SUFFIXES})
  set(CMAKE_FIND_LIBRARY_SUFFIXES ${CMAKE_SHARED_LIBRARY_SUFFIX})
endif()
find_library(SAMEBOY_LIB NAMES sameboy_libretro${CMAKE_SHARED_LIBRARY_SUFFIX} PATH_SUFFIXES libretro)
if(CMAKE_SYSTEM_NAME STREQUAL Windows)
  set(CMAKE_FIND_LIBRARY_SUFFIXES ${_CMAKE_FIND_LIBRARY_SUFFIXES})
endif()

set(SAMEBOY_CUSTOM_BINARY ${SAMEBOY_LIB}
    ${PROJECT_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX})

build_addon(${PROJECT_NAME} SAMEBOY "")

include(CPack)

=== depends/common/sameboy/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(sameboy)

list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR})

include(ExternalProject)

string(TOUPPER ${PROJECT_NAME} PROJECT_NAME_UC)

# Jenkins CI jobs can have this env var set
# Use it if available
if(DEFINED ENV{BUILDTHREADS})
  set(build_job_count -j$ENV{BUILDTHREADS})
  message(STATUS "Using $ENV{BUILDTHREADS} threads from ENV var BUILDTHREADS")
else()
  # Most likely a non CI build, so do a best attempt just using ProcessorCount
  include(ProcessorCount)
  ProcessorCount(cpu_count)
  if(NOT cpu_count EQUAL 0)
    set(build_job_count -j${cpu_count})
    message(STATUS "Using ${cpu_count} threads deduced by ProcessorCount")
  endif()
endif()

set(LIBRETRO_BINARY_DIR libretro)
set(LIBRETRO_SONAME sameboy_libretro${CMAKE_SHARED_LIBRARY_SUFFIX})
set(LIBRETRO_JNISONAME libretro${CMAKE_SHARED_LIBRARY_SUFFIX})

if(CMAKE_BUILD_TYPE MATCHES Debug)
  set(LIBRETRO_DEBUG DEBUG=1)
endif()

if(CORE_SYSTEM_NAME STREQUAL windows)
  find_package(MinGW REQUIRED)
  if(CPU STREQUAL arm64)
    set(MSYSTEM MINGW64)
  else()
    set(MSYSTEM MINGW32)
  endif()
  set(BUILD_COMMAND ${MINGW_MAKE}
                    -C libretro
                    -f Makefile
                    ${build_job_count}
                    ${LIBRETRO_DEBUG}
                    GIT_VERSION=
                    MSYSTEM=${MSYSTEM}
                    platform=win
                    )
elseif(CORE_SYSTEM_NAME STREQUAL linux)
  set(BUILD_COMMAND $(MAKE)
                    -C libretro
                    -f Makefile
                    ${build_job_count}
                    ${LIBRETRO_DEBUG}
                    GIT_VERSION=
                    platform=unix
                    )
elseif(CORE_SYSTEM_NAME STREQUAL osx)
  if(CPU STREQUAL arm64)
    set(ARCH arm)
  else()
    set(ARCH intel)
  endif()
  set(BUILD_COMMAND $(MAKE)
                    -C libretro
                    -f Makefile
                    ${build_job_count}
                    ${LIBRETRO_DEBUG}
                    arch=${ARCH}
                    CROSS_COMPILE=1
                    GIT_VERSION=
                    LIBRETRO_APPLE_ISYSROOT=${CMAKE_OSX_SYSROOT}
                    LIBRETRO_APPLE_PLATFORM=${CPU}-apple-macos
                    platform=osx
                    )
elseif(CORE_SYSTEM_NAME STREQUAL ios OR CORE_SYSTEM_NAME STREQUAL darwin_embedded)
  if(CORE_PLATFORM_NAME STREQUAL ios)
    set(LIBRETRO_SONAME sameboy_libretro_ios${CMAKE_SHARED_LIBRARY_SUFFIX})
    if(CPU STREQUAL arm64)
      set(PLATFORM ios-arm64)
    else()
      set(PLATFORM ios)
    endif()
    set(BUILD_COMMAND IOSSDK=${CMAKE_OSX_SYSROOT} $(MAKE)
                                                  -C libretro
                                                  -f Makefile
                                                  ${build_job_count}
                                                  ${LIBRETRO_DEBUG}
                                                  GIT_VERSION=
                                                  platform=${PLATFORM}
                                                  )
  elseif(CORE_PLATFORM_NAME STREQUAL tvos)
    set(LIBRETRO_SONAME sameboy_libretro_tvos${CMAKE_SHARED_LIBRARY_SUFFIX})
    set(BUILD_COMMAND IOSSDK=${CMAKE_OSX_SYSROOT} $(MAKE)
                                                  -C libretro
                                                  -f Makefile
                                                  ${build_job_count}
                                                  ${LIBRETRO_DEBUG}
                                                  GIT_VERSION=
                                                  platform=tvos-arm64
                                                  )
  endif()
elseif(CORE_SYSTEM_NAME STREQUAL android)
  if(NOT NDKROOT)
    message(FATAL_ERROR "${PROJECT_NAME} needs NDKROOT for Android. Missing Toolchain file?")
  endif()
  if(CPU STREQUAL armeabi-v7a OR CPU STREQUAL arm64-v8a)
    set(PLATFORM ${CPU})
  elseif(CPU STREQUAL i686)
    set(PLATFORM x86)
  else()
    message(FATAL_ERROR "${PROJECT_NAME} needs Android ${CPU} build command in CMakeLists.txt!")
  endif()
  set(BUILD_COMMAND GNUMAKE=$(MAKE) ${NDKROOT}/ndk-build
                                    -C libretro/jni
                                    ${build_job_count}
                                    ${LIBRETRO_DEBUG}
                                    APP_ABI=${PLATFORM}
                                    APP_SHORT_COMMANDS=true
                                    GIT_VERSION=
                                    NDK_LIBS_OUT=${PROJECT_SOURCE_DIR}/${LIBRETRO_BINARY_DIR}
                                    V=1
                                    V7NEONOPTIMIZATION=1
                                    
                    && cp ${PROJECT_SOURCE_DIR}/${LIBRETRO_BINARY_DIR}/${PLATFORM}/${LIBRETRO_JNISONAME} ${PROJECT_SOURCE_DIR}/${LIBRETRO_BINARY_DIR}/${LIBRETRO_SONAME})
elseif(CORE_SYSTEM_NAME STREQUAL freebsd)
  set(BUILD_COMMAND $(MAKE)
                    -C libretro
                    -f Makefile
                    ${build_job_count}
                    ${LIBRETRO_DEBUG}
                    GIT_VERSION=
                    platform=unix
                    )
else()
  message(FATAL_ERROR "${PROJECT_NAME} - Unknown system: ${CORE_SYSTEM_NAME}")
endif()

externalproject_add(${PROJECT_NAME}
                    SOURCE_DIR ${PROJECT_SOURCE_DIR}
                    PREFIX ${PROJECT_NAME}
                    CONFIGURE_COMMAND ""
                    INSTALL_COMMAND ""
                    BUILD_COMMAND ${BUILD_COMMAND}
                    BUILD_IN_SOURCE 1)

# install the generated shared library
install(FILES ${PROJECT_SOURCE_DIR}/${LIBRETRO_BINARY_DIR}/${LIBRETRO_SONAME}
        DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/libretro RENAME sameboy_libretro${CMAKE_SHARED_LIBRARY_SUFFIX})

=== depends/windows/mingw/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(mingw)

# TODO: Upload msys2 packages to mirrors
#foreach(repo msys mingw32 mingw64)
#  if(${repo} STREQUAL msys)
#    file(WRITE ${CMAKE_CURRENT_SOURCE_DIR}/etc/pacman.d/mirrorlist.${repo} "Server = http://mirrors.kodi.tv/build-deps/win32/msys2/repos/${repo}2/$arch\n")
#  else()
#    file(WRITE ${CMAKE_CURRENT_SOURCE_DIR}/etc/pacman.d/mirrorlist.${repo} "Server = http://mirrors.kodi.tv/build-deps/win32/msys2/repos/${repo}\n")
#  endif()
#endforeach()

include(CheckSymbolExists)
check_symbol_exists(_X86_ "Windows.h" _X86_)
check_symbol_exists(_AMD64_ "Windows.h" _AMD64_)
check_symbol_exists(_M_ARM64 "Windows.h" _M_ARM64)

if(_X86_)
   set(HOST mingw-w64-i686)
   set(MINGW_PATH "mingw32")
elseif(_AMD64_)
   set(HOST mingw-w64-x86_64)
   set(MINGW_PATH "mingw64")
elseif(_M_ARM64)
   set(HOST mingw-w64-x86_64)
   set(MINGW_PATH "mingw64")
else()
   message(FATAL_ERROR "Unsupported architecture")
endif()

execute_process(COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/usr/bin/bash.exe --login -c "pacman-key --init" ERROR_QUIET)
execute_process(COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/usr/bin/bash.exe --login -c "pacman --noconfirm -S make ${HOST}-gcc")

file(GLOB_RECURSE shared_libs ${CMAKE_CURRENT_SOURCE_DIR}/${MINGW_PATH}/*.dll.a)
file(REMOVE ${shared_libs})

configure_file(MinGWConfig.cmake.in MinGWConfig.cmake @ONLY)
configure_file(make.bat.in ${CMAKE_CURRENT_SOURCE_DIR}/${MINGW_PATH}/bin/make.bat @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/MinGWConfig.cmake DESTINATION ${CMAKE_INSTALL_PREFIX})

## sameboy 1.0.2

=== debian/changelog ===
sameboy (1.0.2-1) trixie; urgency=low

  * Initial release.

 -- Sébastien Noel <sebastien@twolife.be>  Mon, 11 Aug 2025 12:32:35 +0200

=== debian/control ===
Source: sameboy
Section: games
Priority: optional
Maintainer: Sébastien Noel <sebastien@twolife.be>
Build-Depends: debhelper-compat (= 13), pkgconf, rgbds, libsdl2-dev, libgdk-pixbuf-2.0-dev
Standards-Version: 4.7.2

Package: sameboy
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Game Boy and Game Boy Color emulator
 SameBoy is extremely accurate and includes a wide range of powerful
 debugging features, making it ideal for both casual players and developers.
 .
 In addition to accuracy and developer capabilities, SameBoy has all
 the features one would expect from an emulator,
 from save states to scaling filters.

Package: libretro-sameboy
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: libretro wrapper for SameBoy
 SameBoy is extremely accurate and includes a wide range of powerful
 debugging features, making it ideal for both casual players and developers.
 .
 In addition to accuracy and developer capabilities, SameBoy has all
 the features one would expect from an emulator,
 from save states to scaling filters.
 .
 This package contains a wrapper allowing the SameBoy engine to be
 used with libretro frontends such as RetroArch.

Package: kodi-game-libretro-sameboy
Architecture: any
Multi-Arch: same
Depends: kodi-game-libretro, libretro-sameboy, ${misc:Depends}
Enhances: kodi
Description: Kodi integration for SameBoy
 Nintendo - Game Boy / Color (SameBoy) core for kodi's retroplayer

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_build:
	CC=gcc dh_auto_build -- PREFIX=/usr DATA_DIR=/usr/share/sameboy/
	ln -s ../build/bin/BootROMs BootROMs/prebuilt
	CC=gcc dh_auto_build -- libretro

override_dh_auto_install:
	dh_auto_install -- FREEDESKTOP=true PREFIX=/usr
	mv debian/tmp/usr/bin debian/tmp/usr/games
	rm -rf debian/tmp/usr/share/mime

=== debian/watch ===
version=4
opts="pgpmode=none"
https://github.com/LIJI32/SameBoy/tags .*/[vV]?(\d[^\s+]+)\.tar\.gz

## sameboy 1.0.2+ds

=== debian/changelog ===
sameboy (1.0.2+ds-2) unstable; urgency=medium

  * add patch to remove warning with recent rgbds versions
  * try to fix build on hurd
  * d/control:
    + update Vcs-* fields
    + bump S-V to 4.7.3
    + rewrite long description (Closes: #1128191)

 -- Sébastien Noel <sebastien@twolife.be>  Thu, 19 Feb 2026 09:21:28 +0100

sameboy (1.0.2+ds-1) unstable; urgency=low

  * Initial release. (Closes: #1117933)

 -- Sébastien Noel <sebastien@twolife.be>  Sun, 12 Oct 2025 17:19:33 +0200

=== debian/control ===
Source: sameboy
Section: games
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Sébastien Noel <sebastien@twolife.be>
Build-Depends: debhelper-compat (= 13), pkgconf, rgbds, libopenal-dev, libsdl2-dev, libgdk-pixbuf-2.0-dev
Standards-Version: 4.7.3
Homepage: https://sameboy.github.io/
Vcs-Browser: https://salsa.debian.org/games-team/sameboy
Vcs-Git: https://salsa.debian.org/games-team/sameboy.git

Package: sameboy
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Game Boy, Game Boy Color and Super Game Boy emulator
 SameBoy is an extremely accurate Game Boy, Game Boy Color and Super Game Boy
 emulator and it includes a wide range of powerful debugging features,
 making it ideal for both casual players and developers.
 .
 In addition to accuracy and developer capabilities, SameBoy has all
 the features one would expect from an emulator,
 from save states to scaling filters.

Package: libretro-sameboy
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: libretro wrapper for SameBoy
 SameBoy is an extremely accurate Game Boy, Game Boy Color and Super Game Boy
 emulator and it includes a wide range of powerful debugging features,
 making it ideal for both casual players and developers.
 .
 In addition to accuracy and developer capabilities, SameBoy has all
 the features one would expect from an emulator,
 from save states to scaling filters.
 .
 This package contains a wrapper allowing the SameBoy engine to be
 used with libretro frontends such as RetroArch.

Package: kodi-game-libretro-sameboy
Architecture: any
Multi-Arch: same
Depends: kodi-game-libretro, libretro-sameboy, ${misc:Depends}
Enhances: kodi
Description: Kodi integration for SameBoy core
 This package contains the appropriate Kodi configuration to allow the use of
 the SameBoy libretro core with Kodi via kodi-game-libretro.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- PREFIX=/usr DATA_DIR=/usr/share/sameboy/
	DEBCFLAGS="${CPPFLAGS} ${CFLAGS}" dh_auto_build -- libretro
	sed 's|@PLATFORM@|linux|g;s|@LIBRARY_FILENAME@|sameboy_libretro.so|g' \
	kodi-game/game.libretro.sameboy/addon.xml.in > kodi-game/game.libretro.sameboy/addon.xml

override_dh_auto_install:
	dh_auto_install -- FREEDESKTOP=true PREFIX=/usr
	rm debian/tmp/usr/share/sameboy/LICENSE
	rmdir debian/tmp/usr/share/sameboy/BootROMs

=== debian/watch ===
Version: 5

Template: Github
Owner: LIJI32
Project: SameBoy
Repack: yes
Repacksuffix: +ds
Dversion-Mangle: auto
# do not match on "libretro" tags
Matching-Pattern: https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/v?([0-9\.]*)

Component: kodi-game
Mode: git
Source: https://github.com/kodi-game/game.libretro.sameboy.git
Matching-Pattern: HEAD
Compression: xz
Git-Pretty: %cd
